var map_canvas_selector = 'map';
var markers = [];
var map;

function drawMarker (carid, lat, lon)
{
	if (lat != 0.0 && lon != 0.0)
    {
    	var icon = 'images/blue_full_box_tag.png';
		
		var iconConfig = {
            iconUrl : icon,
            iconAnchor : [12, 41],
            popupAnchor : [1, -34]
    	};
    	
    	// If marker already exists on map, update it
    	if (markers[carid])
    	{
    		var Icon = L.icon(iconConfig);
    		var marker = markers[carid];
    		marker.setLatLng([lat, lon]);
    		marker.setIcon(Icon);
    	}
    	// If marker does not already exist on map, create a new marker
    	else
    	{
            markers[carid] = L.marker([lat, lon], { icon: L.icon(iconConfig) }).addTo(map); //.bindPopup(html);
		}
	}
}

'use strict';
(function(){
	// Setup the map
	var osmUrl = 'http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
	var osm = L.tileLayer(osmUrl);
	map = new L.Map('map', {layers: [osm], center: new L.LatLng(34.8661,-84.9741), zoom: 10 });

	LiveView.connect({url: '/lv/client/'}).then(
		function(connection){
			connection.subscribe(
				new LiveView.Query('SELECT * FROM Torque ORDER BY time DESC'),
				{
					onInsert: function(result){
						var carid = 'CAR' + result.tuple.fieldMap['id'];
	   					var lat = result.tuple.fieldMap['kff1006'];
	    				var lon = result.tuple.fieldMap['kff1005'];
					
						drawMarker(carid, lat, lon);
					},
					onUpdate: function(result){
						var carid = 'CAR' + result.tuple.fieldMap['id'];
	   					var lat = result.tuple.fieldMap['kff1006'];
	    				var lon = result.tuple.fieldMap['kff1005'];
	    				
	    				drawMarker(carid, lat, lon);
					},
					onDelete: function(result){
						var carid = 'CAR' + result.tuple.fieldMap['id'];
						markers.splice(markers.indexOf(carid), 1);
					}
				}
			);
		},
		function(error){
			console.log('ERROR - ' + error.toString());
		}
	);

})();